#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#if defined __linux__ || defined __APPLE__

#include <openssl/md5.h>

#else
#include <md5.h>
#endif

#include "advent_utility.h"

char *md5_str(const char *input) {
    unsigned char digest[16];

#if defined __linux__ || defined __APPLE__
    MD5_CTX context;
    MD5_Init(&context);
    MD5_Update(&context, input, strlen(input));
    MD5_Final(digest, &context);
#else
    struct MD5Context context;
    MD5Init(&context);
    MD5Update(&context, input, strlen(input));
    MD5Final(digest, &context);
#endif

    char *md5string = malloc(33);
    for (int i = 0; i < 16; ++i) {
        snprintf(&md5string[i * 2], 33, "%02x", (unsigned int) digest[i]);
    }
    return md5string;
}

Vector *string_to_int_vector(const char *input_string, const char* delim) {
    char *copy = strdup(input_string);
    char* token = strtok(copy, delim);
    Vector *v = malloc(sizeof(Vector));
    vec_init(v, free);

    while (token != NULL) {
        int *i = malloc(sizeof(int));
        *i = atoi(token);
        vec_push(v, i, NULL);
        token = strtok(NULL, delim);
    }

    free(copy);
    return v;
}

